com.fasterxml.jackson.core.filter

## Class FilteringParserDelegate

- java.lang.Object
- - com.fasterxml.jackson.core.JsonParser
  - - com.fasterxml.jackson.core.util.JsonParserDelegate
    - - com.fasterxml.jackson.core.filter.FilteringParserDelegate

All Implemented Interfaces:
  Versioned, Closeable, AutoCloseable

    public class FilteringParserDelegate
    extends JsonParserDelegate

Specialized `JsonParserDelegate` that allows use of `TokenFilter` for outputting a subset of content that is visible to caller

Since:
  2.6

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.core.JsonParser

`JsonParser.Feature, JsonParser.NumberType, JsonParser.NumberTypeFP`

### Field Summary

Fields
`protected boolean` `_allowMultipleMatches` Flag that determines whether filtering will continue after the first match is indicated or not: if `false`, output is based on just the first full match (returning `TokenFilter.INCLUDE_ALL`) and no more checks are made; if `true` then filtering will be applied as necessary until end of content.
`protected JsonToken` `_currToken` Last token retrieved via `nextToken()`, if any.
`protected TokenFilterContext` `_exposedContext` In cases where `_headContext` is "ahead" of context exposed to caller, this context points to what is currently exposed to caller.
`protected TokenFilterContext` `_headContext` During traversal this is the actual "open" parse tree, which sometimes is the same as `_exposedContext`, and at other times is ahead of it.
`protected TokenFilter.Inclusion` `_inclusion` Flag that determines whether path leading up to included content should also be automatically included or not.
`protected TokenFilter` `_itemFilter` State that applies to the item within container, used where applicable.
`protected JsonToken` `_lastClearedToken` Last cleared token, if any: that is, value that was in effect when `clearCurrentToken()` was called.
`protected int` `_matchCount` Number of tokens for which `TokenFilter.INCLUDE_ALL` has been returned.
`protected TokenFilter` `rootFilter` Object consulted to determine whether to write parts of content generator is asked to write or not.

### Fields inherited from class com.fasterxml.jackson.core.util.JsonParserDelegate

`delegate`

### Fields inherited from class com.fasterxml.jackson.core.JsonParser

`_features, _requestPayload, DEFAULT_READ_CAPABILITIES`

### Constructor Summary

Constructors
Constructor and Description
`FilteringParserDelegate(JsonParser p, TokenFilter f, boolean includePath, boolean allowMultipleMatches)` Deprecated.
`FilteringParserDelegate(JsonParser p, TokenFilter f, TokenFilter.Inclusion inclusion, boolean allowMultipleMatches)`

### Method Summary

All Methods Instance Methods Concrete Methods Deprecated Methods
`protected JsonStreamContext` `_filterContext()`
`protected JsonToken` `_nextToken2()`
`protected JsonToken` `_nextTokenWithBuffering(TokenFilterContext buffRoot)`
`void` `clearCurrentToken()` Method called to "consume" the current token by effectively removing it so that `JsonParser.hasCurrentToken()` returns false, and `JsonParser.getCurrentToken()` null).
`JsonLocation` `currentLocation()` Method that returns location of the last processed input unit (character or byte) from the input; usually for error reporting purposes.
`String` `currentName()` Method that can be called to get the name associated with the current token: for `JsonToken.FIELD_NAME`s it will be the same as what `JsonParser.getText()` returns; for field values it will be preceding field name; and for others (array values, root-level values) null.
`JsonToken` `currentToken()` Accessor to find which token parser currently points to, if any; null will be returned if none.
`int` `currentTokenId()` Method similar to `JsonParser.getCurrentToken()` but that returns an `int` instead of `JsonToken` (enum value).
`JsonLocation` `currentTokenLocation()` Method that return the starting location of the current (most recently returned) token; that is, the position of the first input unit (character or byte) from input that starts the current token.
`BigInteger` `getBigIntegerValue()` Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_INT` and it can not be used as a Java long primitive type due to its magnitude.
`byte[]` `getBinaryValue(Base64Variant b64variant)` Method that can be used to read (and consume -- results may not be accessible using other methods after the call) base64-encoded binary data included in the current textual JSON value.
`boolean` `getBooleanValue()` Convenience accessor that can be called when the current token is `JsonToken.VALUE_TRUE` or `JsonToken.VALUE_FALSE`, to return matching `boolean` value.
`byte` `getByteValue()` Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_INT` and it can be expressed as a value of Java byte primitive type.
`JsonLocation` `getCurrentLocation()` Deprecated.
`String` `getCurrentName()` Deprecated.
`JsonToken` `getCurrentToken()` Deprecated.
`int` `getCurrentTokenId()` Deprecated.
`BigDecimal` `getDecimalValue()` Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_FLOAT` or `JsonToken.VALUE_NUMBER_INT`.
`double` `getDoubleValue()` Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_FLOAT` and it can be expressed as a Java double primitive type.
`Object` `getEmbeddedObject()` Accessor that can be called if (and only if) the current token is `JsonToken.VALUE_EMBEDDED_OBJECT`.
`TokenFilter` `getFilter()`
`float` `getFloatValue()` Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_FLOAT` and it can be expressed as a Java float primitive type.
`int` `getIntValue()` Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_INT` and it can be expressed as a value of Java int primitive type.
`JsonToken` `getLastClearedToken()` Method that can be called to get the last token that was cleared using `JsonParser.clearCurrentToken()`.
`long` `getLongValue()` Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_INT` and it can be expressed as a Java long primitive type.
`int` `getMatchCount()` Accessor for finding number of matches, where specific token and sub-tree starting (if structured type) are passed.
`JsonParser.NumberType` `getNumberType()` If current token is of type `JsonToken.VALUE_NUMBER_INT` or `JsonToken.VALUE_NUMBER_FLOAT`, returns one of `JsonParser.NumberType` constants; otherwise returns `null`.
`Number` `getNumberValue()` Generic number value accessor method that will work for all kinds of numeric values.
`JsonStreamContext` `getParsingContext()` Method that can be used to access current parsing context reader is in.
`short` `getShortValue()` Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_INT` and it can be expressed as a value of Java short primitive type.
`String` `getText()` Method for accessing textual representation of the current token; if no current token (before first call to `JsonParser.nextToken()`, or after encountering end-of-input), returns null.
`char[]` `getTextCharacters()` Method similar to `JsonParser.getText()`, but that will return underlying (unmodifiable) character array that contains textual value, instead of constructing a String object to contain this information.
`int` `getTextLength()` Accessor used with `JsonParser.getTextCharacters()`, to know length of String stored in returned buffer.
`int` `getTextOffset()` Accessor used with `JsonParser.getTextCharacters()`, to know offset of the first text content character within buffer.
`JsonLocation` `getTokenLocation()` Deprecated.
`boolean` `getValueAsBoolean()` Method that will try to convert value of current token to a boolean.
`boolean` `getValueAsBoolean(boolean defaultValue)` Method that will try to convert value of current token to a boolean.
`double` `getValueAsDouble()` Method that will try to convert value of current token to a Java double.
`double` `getValueAsDouble(double defaultValue)` Method that will try to convert value of current token to a Java double.
`int` `getValueAsInt()` Method that will try to convert value of current token to a Java `int` value.
`int` `getValueAsInt(int defaultValue)` Method that will try to convert value of current token to a int.
`long` `getValueAsLong()` Method that will try to convert value of current token to a long.
`long` `getValueAsLong(long defaultValue)` Method that will try to convert value of current token to a long.
`String` `getValueAsString()` Method that will try to convert value of current token to a `String`.
`String` `getValueAsString(String defaultValue)` Method that will try to convert value of current token to a `String`.
`boolean` `hasCurrentToken()` Method for checking whether parser currently points to a token (and data for that token is available).
`boolean` `hasTextCharacters()` Method that can be used to determine whether calling of `JsonParser.getTextCharacters()` would be the most efficient way to access textual content for the event parser currently points to.
`boolean` `hasToken(JsonToken t)` Method that is functionally equivalent to: `return currentToken() == t` but may be more efficiently implemented.
`boolean` `hasTokenId(int id)` Method that is functionally equivalent to: `return currentTokenId() == id` but may be more efficiently implemented.
`boolean` `isExpectedStartArrayToken()` Specialized accessor that can be used to verify that the current token indicates start array (usually meaning that current token is `JsonToken.START_ARRAY`) when start array is expected.
`boolean` `isExpectedStartObjectToken()` Similar to `JsonParser.isExpectedStartArrayToken()`, but checks whether stream currently points to `JsonToken.START_OBJECT`.
`JsonToken` `nextToken()` Main iteration method, which will advance stream enough to determine type of the next token, if any.
`JsonToken` `nextValue()` Iteration method that will advance stream enough to determine type of the next token that is a value type (including JSON Array and Object start/end markers).
`void` `overrideCurrentName(String name)` Method that can be used to change what is considered to be the current (field) name.
`int` `readBinaryValue(Base64Variant b64variant, OutputStream out)` Similar to `JsonParser.readBinaryValue(OutputStream)` but allows explicitly specifying base64 variant to use.
`JsonParser` `skipChildren()` Need to override, re-implement similar to how method defined in `ParserMinimalBase`, to keep state correct here.

### Methods inherited from class com.fasterxml.jackson.core.util.JsonParserDelegate

`assignCurrentValue, canParseAsync, canReadObjectId, canReadTypeId, canUseSchema, close, currentValue, delegate, disable, enable, finishToken, getCodec, getCurrentValue, getFeatureMask, getInputSource, getNonBlockingInputFeeder, getNumberTypeFP, getNumberValueDeferred, getNumberValueExact, getObjectId, getReadCapabilities, getSchema, getText, getTypeId, isClosed, isEnabled, isExpectedNumberIntToken, isNaN, overrideFormatFeatures, overrideStdFeatures, requiresCustomCodec, setCodec, setCurrentValue, setFeatureMask, setSchema, streamReadConstraints, version`

### Methods inherited from class com.fasterxml.jackson.core.JsonParser

`_codec, _constructError, _constructReadException, _constructReadException, _constructReadException, _constructReadException, _constructReadException, _constructReadException, _reportUnsupportedOperation, configure, getBinaryValue, getFormatFeatures, isEnabled, nextBooleanValue, nextFieldName, nextFieldName, nextIntValue, nextLongValue, nextTextValue, readBinaryValue, readValueAs, readValueAs, readValueAsTree, readValuesAs, readValuesAs, releaseBuffered, releaseBuffered, setRequestPayloadOnError, setRequestPayloadOnError, setRequestPayloadOnError`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### rootFilter

    protected TokenFilter rootFilter

Object consulted to determine whether to write parts of content generator is asked to write or not.

#### _allowMultipleMatches

    protected boolean _allowMultipleMatches

Flag that determines whether filtering will continue after the first match is indicated or not: if `false`, output is based on just the first full match (returning `TokenFilter.INCLUDE_ALL`) and no more checks are made; if `true` then filtering will be applied as necessary until end of content.

#### _inclusion

    protected TokenFilter.Inclusion _inclusion

Flag that determines whether path leading up to included content should also be automatically included or not. If `false`, no path inclusion is done and only explicitly included entries are output; if `true` then path from main level down to match is also included as necessary.

#### _currToken

    protected JsonToken _currToken

Last token retrieved via `nextToken()`, if any. Null before the first call to `nextToken()`, as well as if token has been explicitly cleared

#### _lastClearedToken

    protected JsonToken _lastClearedToken

Last cleared token, if any: that is, value that was in effect when `clearCurrentToken()` was called.

#### _headContext

    protected TokenFilterContext _headContext

During traversal this is the actual "open" parse tree, which sometimes is the same as `_exposedContext`, and at other times is ahead of it. Note that this context is never null.

#### _exposedContext

    protected TokenFilterContext _exposedContext

In cases where `_headContext` is "ahead" of context exposed to caller, this context points to what is currently exposed to caller. When the two are in sync, this context reference will be `null`.

#### _itemFilter

    protected TokenFilter _itemFilter

State that applies to the item within container, used where applicable. Specifically used to pass inclusion state between property name and property, and also used for array elements.

#### _matchCount

    protected int _matchCount

Number of tokens for which `TokenFilter.INCLUDE_ALL` has been returned.

### Constructor Detail

#### FilteringParserDelegate

    @Deprecated
    public FilteringParserDelegate(JsonParser p,
                                               TokenFilter f,
                                               boolean includePath,
                                               boolean allowMultipleMatches)

Deprecated.

#### FilteringParserDelegate

    public FilteringParserDelegate(JsonParser p,
                                   TokenFilter f,
                                   TokenFilter.Inclusion inclusion,
                                   boolean allowMultipleMatches)

Parameters:
  `p` - Parser to delegate calls to
  `f` - Filter to use
  `inclusion` - Definition of inclusion criteria
  `allowMultipleMatches` - Whether to allow multiple matches

### Method Detail

#### getFilter

    public TokenFilter getFilter()

#### getMatchCount

    public int getMatchCount()

Accessor for finding number of matches, where specific token and sub-tree starting (if structured type) are passed.

Returns:
  Number of matches

#### currentToken

    public JsonToken currentToken()

Description copied from class: `JsonParser`
Accessor to find which token parser currently points to, if any; null will be returned if none. If return value is non-null, data associated with the token is available via other accessor methods.

Overrides:
  `currentToken` in class `JsonParserDelegate`
Returns:
  Type of the token this parser currently points to, if any: null before any tokens have been read, and after end-of-input has been encountered, as well as if the current token has been explicitly cleared.

#### getCurrentToken

    @Deprecated
    public JsonToken getCurrentToken()

Deprecated.
Description copied from class: `JsonParser`
Alias for `JsonParser.currentToken()`, may be deprecated sometime after Jackson 2.13 (will be removed from 3.0).

Overrides:
  `getCurrentToken` in class `JsonParserDelegate`
Returns:
  Type of the token this parser currently points to, if any: null before any tokens have been read, and

#### currentTokenId

    public final int currentTokenId()

Description copied from class: `JsonParser`
Method similar to `JsonParser.getCurrentToken()` but that returns an `int` instead of `JsonToken` (enum value).

Use of int directly is typically more efficient on switch statements, so this method may be useful when building low-overhead codecs. Note, however, that effect may not be big enough to matter: make sure to profile performance before deciding to use this method.

Overrides:
  `currentTokenId` in class `JsonParserDelegate`
Returns:
  `int` matching one of constants from `JsonTokenId`.

#### getCurrentTokenId

    @Deprecated
    public final int getCurrentTokenId()

Deprecated.
Description copied from class: `JsonParser`
Deprecated alias for `JsonParser.currentTokenId()`.

Overrides:
  `getCurrentTokenId` in class `JsonParserDelegate`
Returns:
  `int` matching one of constants from `JsonTokenId`.

#### hasCurrentToken

    public boolean hasCurrentToken()

Description copied from class: `JsonParser`
Method for checking whether parser currently points to a token (and data for that token is available). Equivalent to check for `parser.getCurrentToken() != null`.

Overrides:
  `hasCurrentToken` in class `JsonParserDelegate`
Returns:
  True if the parser just returned a valid token via `JsonParser.nextToken()`; false otherwise (parser was just constructed, encountered end-of-input and returned null from `JsonParser.nextToken()`, or the token has been consumed)

#### hasTokenId

    public boolean hasTokenId(int id)

Description copied from class: `JsonParser`
Method that is functionally equivalent to: `return currentTokenId() == id` but may be more efficiently implemented.

Note that no traversal or conversion is performed; so in some cases calling method like `JsonParser.isExpectedStartArrayToken()` is necessary instead.

Overrides:
  `hasTokenId` in class `JsonParserDelegate`
Parameters:
  `id` - Token id to match (from (@link JsonTokenId})
Returns:
  `True` if the parser current points to specified token

#### hasToken

    public final boolean hasToken(JsonToken t)

Description copied from class: `JsonParser`
Method that is functionally equivalent to: `return currentToken() == t` but may be more efficiently implemented.

Note that no traversal or conversion is performed; so in some cases calling method like `JsonParser.isExpectedStartArrayToken()` is necessary instead.

Overrides:
  `hasToken` in class `JsonParserDelegate`
Parameters:
  `t` - Token to match
Returns:
  `True` if the parser current points to specified token

#### isExpectedStartArrayToken

    public boolean isExpectedStartArrayToken()

Description copied from class: `JsonParser`
Specialized accessor that can be used to verify that the current token indicates start array (usually meaning that current token is `JsonToken.START_ARRAY`) when start array is expected. For some specialized parsers this can return true for other cases as well; this is usually done to emulate arrays in cases underlying format is ambiguous (XML, for example, has no format-level difference between Objects and Arrays; it just has elements).

Default implementation is equivalent to:

       currentToken() == JsonToken.START_ARRAY

but may be overridden by custom parser implementations.

Overrides:
  `isExpectedStartArrayToken` in class `JsonParserDelegate`
Returns:
  True if the current token can be considered as a start-array marker (such `JsonToken.START_ARRAY`); `false` if not

#### isExpectedStartObjectToken

    public boolean isExpectedStartObjectToken()

Description copied from class: `JsonParser`
Similar to `JsonParser.isExpectedStartArrayToken()`, but checks whether stream currently points to `JsonToken.START_OBJECT`.

Overrides:
  `isExpectedStartObjectToken` in class `JsonParserDelegate`
Returns:
  True if the current token can be considered as a start-array marker (such `JsonToken.START_OBJECT`); `false` if not

#### currentLocation

    public JsonLocation currentLocation()

Description copied from class: `JsonParser`
Method that returns location of the last processed input unit (character or byte) from the input; usually for error reporting purposes.

Note that the location is not guaranteed to be accurate (although most implementation will try their best): some implementations may only report specific boundary locations (start or end locations of tokens) and others only return `JsonLocation.NA` due to not having access to input location information (when delegating actual decoding work to other library)

Overrides:
  `currentLocation` in class `JsonParserDelegate`
Returns:
  Location of the last processed input unit (byte or character)

#### getCurrentLocation

    @Deprecated
    public JsonLocation getCurrentLocation()

Deprecated.
Description copied from class: `JsonParser`
Deprecated alias for `JsonParser.currentLocation()` (removed from Jackson 3.0).

Overrides:
  `getCurrentLocation` in class `JsonParserDelegate`
Returns:
  Location of the last processed input unit (byte or character)

#### currentTokenLocation

    public JsonLocation currentTokenLocation()

Description copied from class: `JsonParser`
Method that return the starting location of the current (most recently returned) token; that is, the position of the first input unit (character or byte) from input that starts the current token.

Note that the location is not guaranteed to be accurate (although most implementation will try their best): some implementations may only return `JsonLocation.NA` due to not having access to input location information (when delegating actual decoding work to other library)

Overrides:
  `currentTokenLocation` in class `JsonParserDelegate`
Returns:
  Starting location of the token parser currently points to

#### getTokenLocation

    @Deprecated
    public JsonLocation getTokenLocation()

Deprecated.
Description copied from class: `JsonParser`
Deprecated alias for `JsonParser.currentTokenLocation()` (removed from Jackson 3.0).

Overrides:
  `getTokenLocation` in class `JsonParserDelegate`
Returns:
  Starting location of the token parser currently points to

#### getParsingContext

    public JsonStreamContext getParsingContext()

Description copied from class: `JsonParser`
Method that can be used to access current parsing context reader is in. There are 3 different types: root, array and object contexts, with slightly different available information. Contexts are hierarchically nested, and can be used for example for figuring out part of the input document that correspond to specific array or object (for highlighting purposes, or error reporting). Contexts can also be used for simple xpath-like matching of input, if so desired.

Overrides:
  `getParsingContext` in class `JsonParserDelegate`
Returns:
  Stream input context (`JsonStreamContext`) associated with this parser

#### getCurrentName

    @Deprecated
    public String getCurrentName()
                                      throws IOException

Deprecated.
Description copied from class: `JsonParser`
Deprecated alias of `JsonParser.currentName()`.

Overrides:
  `getCurrentName` in class `JsonParserDelegate`
Returns:
  Name of the current field in the parsing context
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### currentName

    public String currentName()
                       throws IOException

Description copied from class: `JsonParser`
Method that can be called to get the name associated with the current token: for `JsonToken.FIELD_NAME`s it will be the same as what `JsonParser.getText()` returns; for field values it will be preceding field name; and for others (array values, root-level values) null.

Overrides:
  `currentName` in class `JsonParserDelegate`
Returns:
  Name of the current field in the parsing context
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### clearCurrentToken

    public void clearCurrentToken()

Description copied from class: `JsonParser`
Method called to "consume" the current token by effectively removing it so that `JsonParser.hasCurrentToken()` returns false, and `JsonParser.getCurrentToken()` null). Cleared token value can still be accessed by calling `JsonParser.getLastClearedToken()` (if absolutely needed), but usually isn't.

Method was added to be used by the optional data binder, since it has to be able to consume last token used for binding (so that it will not be used again).

Overrides:
  `clearCurrentToken` in class `JsonParserDelegate`

#### getLastClearedToken

    public JsonToken getLastClearedToken()

Description copied from class: `JsonParser`
Method that can be called to get the last token that was cleared using `JsonParser.clearCurrentToken()`. This is not necessarily the latest token read. Will return null if no tokens have been cleared, or if parser has been closed.

Overrides:
  `getLastClearedToken` in class `JsonParserDelegate`
Returns:
  Last cleared token, if any; `null` otherwise

#### overrideCurrentName

    public void overrideCurrentName(String name)

Description copied from class: `JsonParser`
Method that can be used to change what is considered to be the current (field) name. May be needed to support non-JSON data formats or unusual binding conventions; not needed for typical processing.

Note that use of this method should only be done as sort of last resort, as it is a work-around for regular operation.

Overrides:
  `overrideCurrentName` in class `JsonParserDelegate`
Parameters:
  `name` - Name to use as the current name; may be null.

#### nextToken

    public JsonToken nextToken()
                        throws IOException

Description copied from class: `JsonParser`
Main iteration method, which will advance stream enough to determine type of the next token, if any. If none remaining (stream has no content other than possible white space before ending), null will be returned.

Overrides:
  `nextToken` in class `JsonParserDelegate`
Returns:
  Next token from the stream, if any found, or null to indicate end-of-input
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### _nextToken2

    protected final JsonToken _nextToken2()
                                   throws IOException

Throws:
  `IOException`

#### _nextTokenWithBuffering

    protected final JsonToken _nextTokenWithBuffering(TokenFilterContext buffRoot)
                                               throws IOException

Throws:
  `IOException`

#### nextValue

    public JsonToken nextValue()
                        throws IOException

Description copied from class: `JsonParser`
Iteration method that will advance stream enough to determine type of the next token that is a value type (including JSON Array and Object start/end markers). Or put another way, nextToken() will be called once, and if `JsonToken.FIELD_NAME` is returned, another time to get the value for the field. Method is most useful for iterating over value entries of JSON objects; field name will still be available by calling `JsonParser.currentName()` when parser points to the value.

Overrides:
  `nextValue` in class `JsonParserDelegate`
Returns:
  Next non-field-name token from the stream, if any found, or null to indicate end-of-input (or, for non-blocking parsers, `JsonToken.NOT_AVAILABLE` if no tokens were available yet)
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### skipChildren

    public JsonParser skipChildren()
                            throws IOException

Need to override, re-implement similar to how method defined in `ParserMinimalBase`, to keep state correct here.

Overrides:
  `skipChildren` in class `JsonParserDelegate`
Returns:
  This parser, to allow call chaining
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getText

    public String getText()
                   throws IOException

Description copied from class: `JsonParser`
Method for accessing textual representation of the current token; if no current token (before first call to `JsonParser.nextToken()`, or after encountering end-of-input), returns null. Method can be called for any token type.

Overrides:
  `getText` in class `JsonParserDelegate`
Returns:
  Textual value associated with the current token (one returned by `JsonParser.nextToken()` or other iteration methods)
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems, including if the text is too large, see `StreamReadConstraints.Builder.maxStringLength(int)`

#### hasTextCharacters

    public boolean hasTextCharacters()

Description copied from class: `JsonParser`
Method that can be used to determine whether calling of `JsonParser.getTextCharacters()` would be the most efficient way to access textual content for the event parser currently points to.

Default implementation simply returns false since only actual implementation class has knowledge of its internal buffering state. Implementations are strongly encouraged to properly override this method, to allow efficient copying of content by other code.

Overrides:
  `hasTextCharacters` in class `JsonParserDelegate`
Returns:
  True if parser currently has character array that can be efficiently returned via `JsonParser.getTextCharacters()`; false means that it may or may not exist

#### getTextCharacters

    public char[] getTextCharacters()
                             throws IOException

Description copied from class: `JsonParser`
Method similar to `JsonParser.getText()`, but that will return underlying (unmodifiable) character array that contains textual value, instead of constructing a String object to contain this information. Note, however, that:

- Textual contents are not guaranteed to start at index 0 (rather, call `JsonParser.getTextOffset()`) to know the actual offset
- Length of textual contents may be less than the length of returned buffer: call `JsonParser.getTextLength()` for actual length of returned content.

Note that caller MUST NOT modify the returned character array in any way -- doing so may corrupt current parser state and render parser instance useless.

The only reason to call this method (over `JsonParser.getText()`) is to avoid construction of a String object (which will make a copy of contents).

Overrides:
  `getTextCharacters` in class `JsonParserDelegate`
Returns:
  Buffer that contains the current textual value (but not necessarily at offset 0, and not necessarily until the end of buffer)
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems, including if the text is too large, see `StreamReadConstraints.Builder.maxStringLength(int)`

#### getTextLength

    public int getTextLength()
                      throws IOException

Description copied from class: `JsonParser`
Accessor used with `JsonParser.getTextCharacters()`, to know length of String stored in returned buffer.

Overrides:
  `getTextLength` in class `JsonParserDelegate`
Returns:
  Number of characters within buffer returned by `JsonParser.getTextCharacters()` that are part of textual content of the current token.
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getTextOffset

    public int getTextOffset()
                      throws IOException

Description copied from class: `JsonParser`
Accessor used with `JsonParser.getTextCharacters()`, to know offset of the first text content character within buffer.

Overrides:
  `getTextOffset` in class `JsonParserDelegate`
Returns:
  Offset of the first character within buffer returned by `JsonParser.getTextCharacters()` that is part of textual content of the current token.
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getBigIntegerValue

    public BigInteger getBigIntegerValue()
                                  throws IOException

Description copied from class: `JsonParser`
Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_INT` and it can not be used as a Java long primitive type due to its magnitude. It can also be called for `JsonToken.VALUE_NUMBER_FLOAT`; if so, it is equivalent to calling `JsonParser.getDecimalValue()` and then constructing a `BigInteger` from that value.

Overrides:
  `getBigIntegerValue` in class `JsonParserDelegate`
Returns:
  Current number value as `BigInteger` (if numeric token); otherwise exception thrown
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getBooleanValue

    public boolean getBooleanValue()
                            throws IOException

Description copied from class: `JsonParser`
Convenience accessor that can be called when the current token is `JsonToken.VALUE_TRUE` or `JsonToken.VALUE_FALSE`, to return matching `boolean` value. If the current token is of some other type, `JsonParseException` will be thrown

Overrides:
  `getBooleanValue` in class `JsonParserDelegate`
Returns:
  `True` if current token is `JsonToken.VALUE_TRUE`, `false` if current token is `JsonToken.VALUE_FALSE`; otherwise throws `JsonParseException`
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getByteValue

    public byte getByteValue()
                      throws IOException

Description copied from class: `JsonParser`
Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_INT` and it can be expressed as a value of Java byte primitive type. Note that in addition to "natural" input range of `[-128, 127]`, this also allows "unsigned 8-bit byte" values `[128, 255]`: but for this range value will be translated by truncation, leading to sign change.

It can also be called for `JsonToken.VALUE_NUMBER_FLOAT`; if so, it is equivalent to calling `JsonParser.getDoubleValue()` and then casting; except for possible overflow/underflow exception.

Note: if the resulting integer value falls outside range of `[-128, 255]`, a `InputCoercionException` will be thrown to indicate numeric overflow/underflow.

Overrides:
  `getByteValue` in class `JsonParserDelegate`
Returns:
  Current number value as `byte` (if numeric token within range of `[-128, 255]`); otherwise exception thrown
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getShortValue

    public short getShortValue()
                        throws IOException

Description copied from class: `JsonParser`
Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_INT` and it can be expressed as a value of Java short primitive type. It can also be called for `JsonToken.VALUE_NUMBER_FLOAT`; if so, it is equivalent to calling `JsonParser.getDoubleValue()` and then casting; except for possible overflow/underflow exception.

Note: if the resulting integer value falls outside range of Java short, a `InputCoercionException` will be thrown to indicate numeric overflow/underflow.

Overrides:
  `getShortValue` in class `JsonParserDelegate`
Returns:
  Current number value as `short` (if numeric token within Java 16-bit signed `short` range); otherwise exception thrown
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getDecimalValue

    public BigDecimal getDecimalValue()
                               throws IOException

Description copied from class: `JsonParser`
Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_FLOAT` or `JsonToken.VALUE_NUMBER_INT`. No under/overflow exceptions are ever thrown.

Overrides:
  `getDecimalValue` in class `JsonParserDelegate`
Returns:
  Current number value as `BigDecimal` (if numeric token); otherwise exception thrown
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getDoubleValue

    public double getDoubleValue()
                          throws IOException

Description copied from class: `JsonParser`
Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_FLOAT` and it can be expressed as a Java double primitive type. It can also be called for `JsonToken.VALUE_NUMBER_INT`; if so, it is equivalent to calling `JsonParser.getLongValue()` and then casting; except for possible overflow/underflow exception.

Note: if the value falls outside of range of Java double, a `InputCoercionException` will be thrown to indicate numeric overflow/underflow.

Overrides:
  `getDoubleValue` in class `JsonParserDelegate`
Returns:
  Current number value as `double` (if numeric token within Java `double` range); otherwise exception thrown
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getFloatValue

    public float getFloatValue()
                        throws IOException

Description copied from class: `JsonParser`
Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_FLOAT` and it can be expressed as a Java float primitive type. It can also be called for `JsonToken.VALUE_NUMBER_INT`; if so, it is equivalent to calling `JsonParser.getLongValue()` and then casting; except for possible overflow/underflow exception.

Note: if the value falls outside of range of Java float, a `InputCoercionException` will be thrown to indicate numeric overflow/underflow.

Overrides:
  `getFloatValue` in class `JsonParserDelegate`
Returns:
  Current number value as `float` (if numeric token within Java `float` range); otherwise exception thrown
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getIntValue

    public int getIntValue()
                    throws IOException

Description copied from class: `JsonParser`
Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_INT` and it can be expressed as a value of Java int primitive type. It can also be called for `JsonToken.VALUE_NUMBER_FLOAT`; if so, it is equivalent to calling `JsonParser.getDoubleValue()` and then casting; except for possible overflow/underflow exception.

Note: if the resulting integer value falls outside range of Java `int`, a `InputCoercionException` may be thrown to indicate numeric overflow/underflow.

Overrides:
  `getIntValue` in class `JsonParserDelegate`
Returns:
  Current number value as `int` (if numeric token within Java 32-bit signed `int` range); otherwise exception thrown
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getLongValue

    public long getLongValue()
                      throws IOException

Description copied from class: `JsonParser`
Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_INT` and it can be expressed as a Java long primitive type. It can also be called for `JsonToken.VALUE_NUMBER_FLOAT`; if so, it is equivalent to calling `JsonParser.getDoubleValue()` and then casting to int; except for possible overflow/underflow exception.

Note: if the token is an integer, but its value falls outside of range of Java long, a `InputCoercionException` may be thrown to indicate numeric overflow/underflow.

Overrides:
  `getLongValue` in class `JsonParserDelegate`
Returns:
  Current number value as `long` (if numeric token within Java 32-bit signed `long` range); otherwise exception thrown
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getNumberType

    public JsonParser.NumberType getNumberType()
                                        throws IOException

Description copied from class: `JsonParser`
If current token is of type `JsonToken.VALUE_NUMBER_INT` or `JsonToken.VALUE_NUMBER_FLOAT`, returns one of `JsonParser.NumberType` constants; otherwise returns `null`.

Overrides:
  `getNumberType` in class `JsonParserDelegate`
Returns:
  Type of current number, if parser points to numeric token; `null` otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getNumberValue

    public Number getNumberValue()
                          throws IOException

Description copied from class: `JsonParser`
Generic number value accessor method that will work for all kinds of numeric values. It will return the optimal (simplest/smallest possible) wrapper object that can express the numeric value just parsed.

Overrides:
  `getNumberValue` in class `JsonParserDelegate`
Returns:
  Numeric value of the current token in its most optimal representation
Throws:
  `IOException` - Problem with access: `JsonParseException` if the current token is not numeric, or if decoding of the value fails (invalid format for numbers); plain `IOException` if underlying content read fails (possible if values are extracted lazily)

#### getValueAsInt

    public int getValueAsInt()
                      throws IOException

Description copied from class: `JsonParser`
Method that will try to convert value of current token to a Java `int` value. Numbers are coerced using default Java rules; booleans convert to 0 (false) and 1 (true), and Strings are parsed using default Java language integer parsing rules.

If representation can not be converted to an int (including structured type markers like start/end Object/Array) default value of 0 will be returned; no exceptions are thrown.

Overrides:
  `getValueAsInt` in class `JsonParserDelegate`
Returns:
  `int` value current token is converted to, if possible; exception thrown otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getValueAsInt

    public int getValueAsInt(int defaultValue)
                      throws IOException

Description copied from class: `JsonParser`
Method that will try to convert value of current token to a int. Numbers are coerced using default Java rules; booleans convert to 0 (false) and 1 (true), and Strings are parsed using default Java language integer parsing rules.

If representation can not be converted to an int (including structured type markers like start/end Object/Array) specified def will be returned; no exceptions are thrown.

Overrides:
  `getValueAsInt` in class `JsonParserDelegate`
Parameters:
  `defaultValue` - Default value to return if conversion to `int` is not possible
Returns:
  `int` value current token is converted to, if possible; `def` otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getValueAsLong

    public long getValueAsLong()
                        throws IOException

Description copied from class: `JsonParser`
Method that will try to convert value of current token to a long. Numbers are coerced using default Java rules; booleans convert to 0 (false) and 1 (true), and Strings are parsed using default Java language integer parsing rules.

If representation can not be converted to a long (including structured type markers like start/end Object/Array) default value of 0L will be returned; no exceptions are thrown.

Overrides:
  `getValueAsLong` in class `JsonParserDelegate`
Returns:
  `long` value current token is converted to, if possible; exception thrown otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getValueAsLong

    public long getValueAsLong(long defaultValue)
                        throws IOException

Description copied from class: `JsonParser`
Method that will try to convert value of current token to a long. Numbers are coerced using default Java rules; booleans convert to 0 (false) and 1 (true), and Strings are parsed using default Java language integer parsing rules.

If representation can not be converted to a long (including structured type markers like start/end Object/Array) specified def will be returned; no exceptions are thrown.

Overrides:
  `getValueAsLong` in class `JsonParserDelegate`
Parameters:
  `defaultValue` - Default value to return if conversion to `long` is not possible
Returns:
  `long` value current token is converted to, if possible; `def` otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getValueAsDouble

    public double getValueAsDouble()
                            throws IOException

Description copied from class: `JsonParser`
Method that will try to convert value of current token to a Java double. Numbers are coerced using default Java rules; booleans convert to 0.0 (false) and 1.0 (true), and Strings are parsed using default Java language floating point parsing rules.

If representation can not be converted to a double (including structured types like Objects and Arrays), default value of 0.0 will be returned; no exceptions are thrown.

Overrides:
  `getValueAsDouble` in class `JsonParserDelegate`
Returns:
  `double` value current token is converted to, if possible; exception thrown otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getValueAsDouble

    public double getValueAsDouble(double defaultValue)
                            throws IOException

Description copied from class: `JsonParser`
Method that will try to convert value of current token to a Java double. Numbers are coerced using default Java rules; booleans convert to 0.0 (false) and 1.0 (true), and Strings are parsed using default Java language floating point parsing rules.

If representation can not be converted to a double (including structured types like Objects and Arrays), specified def will be returned; no exceptions are thrown.

Overrides:
  `getValueAsDouble` in class `JsonParserDelegate`
Parameters:
  `defaultValue` - Default value to return if conversion to `double` is not possible
Returns:
  `double` value current token is converted to, if possible; `def` otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getValueAsBoolean

    public boolean getValueAsBoolean()
                              throws IOException

Description copied from class: `JsonParser`
Method that will try to convert value of current token to a boolean. JSON booleans map naturally; integer numbers other than 0 map to true, and 0 maps to false and Strings 'true' and 'false' map to corresponding values.

If representation can not be converted to a boolean value (including structured types like Objects and Arrays), default value of false will be returned; no exceptions are thrown.

Overrides:
  `getValueAsBoolean` in class `JsonParserDelegate`
Returns:
  `boolean` value current token is converted to, if possible; exception thrown otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getValueAsBoolean

    public boolean getValueAsBoolean(boolean defaultValue)
                              throws IOException

Description copied from class: `JsonParser`
Method that will try to convert value of current token to a boolean. JSON booleans map naturally; integer numbers other than 0 map to true, and 0 maps to false and Strings 'true' and 'false' map to corresponding values.

If representation can not be converted to a boolean value (including structured types like Objects and Arrays), specified def will be returned; no exceptions are thrown.

Overrides:
  `getValueAsBoolean` in class `JsonParserDelegate`
Parameters:
  `defaultValue` - Default value to return if conversion to `boolean` is not possible
Returns:
  `boolean` value current token is converted to, if possible; `def` otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getValueAsString

    public String getValueAsString()
                            throws IOException

Description copied from class: `JsonParser`
Method that will try to convert value of current token to a `String`. JSON Strings map naturally; scalar values get converted to their textual representation. If representation can not be converted to a String value (including structured types like Objects and Arrays and `null` token), default value of null will be returned; no exceptions are thrown.

Overrides:
  `getValueAsString` in class `JsonParserDelegate`
Returns:
  `String` value current token is converted to, if possible; `null` otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getValueAsString

    public String getValueAsString(String defaultValue)
                            throws IOException

Description copied from class: `JsonParser`
Method that will try to convert value of current token to a `String`. JSON Strings map naturally; scalar values get converted to their textual representation. If representation can not be converted to a String value (including structured types like Objects and Arrays and `null` token), specified default value will be returned; no exceptions are thrown.

Overrides:
  `getValueAsString` in class `JsonParserDelegate`
Parameters:
  `defaultValue` - Default value to return if conversion to `String` is not possible
Returns:
  `String` value current token is converted to, if possible; `def` otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getEmbeddedObject

    public Object getEmbeddedObject()
                             throws IOException

Description copied from class: `JsonParser`
Accessor that can be called if (and only if) the current token is `JsonToken.VALUE_EMBEDDED_OBJECT`. For other token types, null is returned.

Note: only some specialized parser implementations support embedding of objects (usually ones that are facades on top of non-streaming sources, such as object trees). One exception is access to binary content (whether via base64 encoding or not) which typically is accessible using this method, as well as `JsonParser.getBinaryValue()`.

Overrides:
  `getEmbeddedObject` in class `JsonParserDelegate`
Returns:
  Embedded value (usually of "native" type supported by format) for the current token, if any; `null otherwise`
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getBinaryValue

    public byte[] getBinaryValue(Base64Variant b64variant)
                          throws IOException

Description copied from class: `JsonParser`
Method that can be used to read (and consume -- results may not be accessible using other methods after the call) base64-encoded binary data included in the current textual JSON value. It works similar to getting String value via `JsonParser.getText()` and decoding result (except for decoding part), but should be significantly more performant.

Note that non-decoded textual contents of the current token are not guaranteed to be accessible after this method is called. Current implementation, for example, clears up textual content during decoding. Decoded binary content, however, will be retained until parser is advanced to the next event.

Overrides:
  `getBinaryValue` in class `JsonParserDelegate`
Parameters:
  `b64variant` - Expected variant of base64 encoded content (see `Base64Variants` for definitions of "standard" variants).
Returns:
  Decoded binary data
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### readBinaryValue

    public int readBinaryValue(Base64Variant b64variant,
                               OutputStream out)
                        throws IOException

Description copied from class: `JsonParser`
Similar to `JsonParser.readBinaryValue(OutputStream)` but allows explicitly specifying base64 variant to use.

Overrides:
  `readBinaryValue` in class `JsonParserDelegate`
Parameters:
  `b64variant` - base64 variant to use
  `out` - Output stream to use for passing decoded binary data
Returns:
  Number of bytes that were decoded and written via `OutputStream`
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### _filterContext

    protected JsonStreamContext _filterContext()